jQuery(document).ready(function($) {

	$(document).on('hover', '[data-toggle="tooltip"]', function() {
		$(this).tooltip();
	});

	// Load Stats Data

	$.post(ajaxurl, {
			'action': 'nnr_as_stats_load',
			'start_date' : getQuerystring(nnr_as_stats_data.prefix_dash + 'start-date'),
			'end_date' : getQuerystring(nnr_as_stats_data.prefix_dash + 'end-date'),
			'post_types': getQuerystring(nnr_as_stats_data.prefix_dash + 'post-types'),
			'user_roles': getQuerystring(nnr_as_stats_data.prefix_dash + 'user-roles'),
			'author' : getQuerystring('author'),
		}, function(response) {

		response = jQuery.parseJSON(response);

		$("#" + nnr_as_stats_data.prefix_dash + "loading-stats").remove();
		$("." + nnr_as_stats_data.prefix_dash + "stats-container").append(response.content);
		$($("." + nnr_as_stats_data.prefix_dash + "author-totals-container")).insertBefore("." + nnr_as_stats_data.prefix_dash + "form-filters");

		$($.bootstrapSortable);

	});

	// Date Pickers

	if ($('#' + nnr_as_stats_data.prefix_dash + 'start-datepicker').length != 0 &&
		$('#' + nnr_as_stats_data.prefix_dash + 'end-datepicker').length != 0) {

		$('#' + nnr_as_stats_data.prefix_dash + 'start-datepicker').datetimepicker({
	        format: 'MM/DD/YYYY'
	    });

		$('#' + nnr_as_stats_data.prefix_dash + 'end-datepicker').datetimepicker({
	        format: 'MM/DD/YYYY'
	    });

		$('#' + nnr_as_stats_data.prefix_dash + 'end-datepicker')
			.data("DateTimePicker")
			.maxDate( moment(nnr_as_stats_data.today, "M/D/Y") );

		$('#' + nnr_as_stats_data.prefix_dash + 'start-datepicker')
			.data("DateTimePicker")
			.maxDate( moment(nnr_as_stats_data.today, "M/D/Y") );

		$('#' + nnr_as_stats_data.prefix_dash + 'end-datepicker')
			.data("DateTimePicker")
			.minDate( $('#' + nnr_as_stats_data.prefix_dash + 'start-datepicker').data("DateTimePicker").date() );

		$('#' + nnr_as_stats_data.prefix_dash + 'start-datepicker').on("dp.change",function (e) {
	       $('#' + nnr_as_stats_data.prefix_dash + 'end-datepicker').data("DateTimePicker").minDate(e.date);
	    });

	    $('#' + nnr_as_stats_data.prefix_dash + 'end-datepicker').on("dp.change",function (e) {
	       $('#' + nnr_as_stats_data.prefix_dash + 'start-datepicker').data("DateTimePicker").maxDate(e.date);
	    });
	}

	// Selectize

	var post_types_options = [];

  	$.each(nnr_as_stats_data.post_types, function( index, value ) {
	  	post_types_options.push({id: index, name: value});

	});

	$('#' + nnr_as_stats_data.prefix_dash + 'post-types').selectize({
		plugins: ['remove_button'],
		delimiter: ',',
		persist: false,
		valueField: 'id',
		labelField: 'name',
		searchField: 'name',
		options: post_types_options,
	});

	// User Roles

	var user_roles_options = [];
  	$.each(nnr_as_stats_data.user_roles, function( index, value ) {
	  	user_roles_options.push({id: value, name: value});
	});

	$('#' + nnr_as_stats_data.prefix_dash + 'user-roles').selectize({
		plugins: ['remove_button'],
		delimiter: ',',
		persist: false,
		valueField: 'id',
		labelField: 'name',
		searchField: 'name',
		options: user_roles_options,
	});

	show_quick_info();

	/**
	 * Show the filters next to the button
	 *
	 * @access public
	 * @return void
	 */
	function show_quick_info() {

		var start_date = '<span class="' + nnr_as_stats_data.prefix_dash +
			'quick-info-label">Start Date:</span> ' +
			$('#' + nnr_as_stats_data.prefix_dash + 'start-date').val();

		var end_date = '<span class="' + nnr_as_stats_data.prefix_dash +
			'quick-info-label">End Date:</span> ' +
			$('#' + nnr_as_stats_data.prefix_dash + 'end-date').val();

		var post_types = '<span class="' + nnr_as_stats_data.prefix_dash +
			'quick-info-label">Post Types:</span> ' +
			$('#' + nnr_as_stats_data.prefix_dash + 'post-types').val();

		var user_roles = '';

		if ( $('#' + nnr_as_stats_data.prefix_dash + 'user-roles').length != 0 ) {
			user_roles = ' | <span class="' + nnr_as_stats_data.prefix_dash +
				'quick-info-label">User Roles:</span> ' +
				$('#' + nnr_as_stats_data.prefix_dash + 'user-roles').val();
		}

		$('.' + nnr_as_stats_data.prefix_dash + 'quick-info').html(start_date + ' | ' + end_date + ' | ' + post_types + user_roles);

	}

    /**
     * Gets a query parameter
     *
     * @access public
     * @param mixed key
     * @param mixed default_
     * @return void
     */
    function getQuerystring(key, default_) {
	  if (default_==null) default_="";
	  key = key.replace(/[\[]/,"\\\[").replace(/[\]]/,"\\\]");
	  var regex = new RegExp("[\\?&]"+key+"=([^&#]*)");
	  var qs = regex.exec(window.location.href);
	  if(qs == null)
	    return default_;
	  else
	    return qs[1];
	}
});
